var jqAlta = jQuery.noConflict(true);
jqAlta(document).ready(function () {
    var xmlBase = undefined,
        sborImportData = undefined,
        sborExportData = undefined,
        jsonCurrency = undefined,
        globalTimeout = null,
        loadFlag = 0,
        loadFlagComplete = 0,
        errorFlag = false,
        config = {
            LIMIT_HINTS: 10,
            DEFAULT_COUNTRY_CODE: '276',
            USE_APU: false,
            NO_TAX: '0%',
            NO_TAX_CONDITION: 'Не облагается',
            NO_DUTY: 'Беспошлинно',
            CONNECT_ERROR: 'Ошибка соединения',
            PATH: '/taksa_widget/taksa_widget.php'
        },
        tnvedRegexp = /^\d{10}$/,
        $container = jqAlta('#alta_taksa'),
        $templates = jqAlta('.altaTaksaTemplate'),
        $calcBtn = jqAlta('#alta_taksa_calc_btn'),
        $notesBtn = jqAlta('#alta_taksa_notes_btn'),
        $form = jqAlta('#alta_taksa_alta_form_input_data'),
        $formErrors = jqAlta('#alta_taksa_form_error'),
        $formTypeSwitch = jqAlta('input[name="alta_taksa_form_type"]', $form),
        $tnvedCode = jqAlta('#alta_taksa_tncode'),
        $countries = jqAlta('#alta_taksa_countries'),
        $countryCode = jqAlta('#alta_taksa_tncountry'),
        $date = jqAlta('#alta_taksa_date'),
        $clear = jqAlta('.altaTaksaForm__clear'),
        $content = jqAlta('#alta_taksa_content'),
        $contractForm = jqAlta('#alta_taksa_contract_param'),
        $hintsWrapper = jqAlta('.altaTaksaHelpers'),
        $hints = jqAlta('.jAltaTaksaHelper', $hintsWrapper),
        $hintsApu = jqAlta('.jAltaTaksaHelperApu', $hintsWrapper),
        $hintsList = jqAlta('.altaTaksaHelper__line--default', $hints),
        $hintsApuList = jqAlta('.altaTaksaHelper__line--apu', $hintsApu),
        $tnvedTitle = jqAlta('#alta_taksa_tnved_name'),
        $notes = jqAlta('#alta_taksa_notes'),
        $notesList = jqAlta('.altaTaksaNotesList', $notes),
        $notesErrors = jqAlta('#alta_taksa_form_error'),
        $params = {
            container: jqAlta('#alta_taksa_params'),
            errors: jqAlta('#alta_taksa_err_params'),
            duty: jqAlta('#alta_taksa_duty'),
            nds: jqAlta('#alta_taksa_nds'),
            acc: jqAlta('#alta_taksa_acc')
        },
        $paramsUser = {
            accOption: null,
            dutyOption: null,
            dutyOptionAntiDumping: null,
            digitCurrencyDate: 0,
            usdRate: 0,
            euroRate: 0
        },
        $contract = {
            currency: jqAlta('#alta_taksa_currency'),
            rurOption: jqAlta('#alta_taksa_currency').find('option').clone(),
            currentCost: jqAlta('.jAltaTaksaCurrencyCost'),
            currentCostValue: jqAlta('#alta_taksa_currency_cost'),
            currentSign: jqAlta('.jCurrencySign'),
            currentCount: jqAlta('.jCurrencyCount'),
            eur: jqAlta('#alta_taksa_eur_cost'),
            usd: jqAlta('#alta_taksa_usd_cost'),
            cost: jqAlta('#alta_taksa_cost_contract'),
            all: jqAlta('#alta_taksa_base_all'),
            duty: jqAlta('input[name="base_duty"]', $content),
            acc: jqAlta('#alta_taksa_base_acc'),
            ed: jqAlta('#alta_taksa_cost_ed'),
            special: jqAlta('#alta_taksa_acc_special'),
            specialPrice: jqAlta('#alta_taksa_acc_special_price'),
            specialCount: jqAlta('#alta_taksa_acc_special_count'),
            isEd: jqAlta('input[name="is_ed"]', $content)
        },
        $calc = {
            table: jqAlta('.altaTaksaTable'),
            sbor: jqAlta('#alta_taksa_sbor_tr td'),
            duty: jqAlta('#alta_taksa_duty_tr td'),
            dutyAntiDumping: jqAlta('#alta_taksa_antidumping_tr td'),
            acc: jqAlta('#alta_taksa_acc_tr td'),
            nds: jqAlta('#alta_taksa_nds_tr td'),
            sum: jqAlta('#alta_taksa_summ_tr th'),
            total: jqAlta('#alta_taksa_itogo_tr th')
        },
        $template = {
            hint: $hintsList.clone(),
            hintApu: $hintsApuList.clone(),
            nds: jqAlta('.altaTaksaTemplateNds', $templates),
            acc: jqAlta('.altaTaksaTemplateAcc', $templates),
            duty: jqAlta('.altaTaksaTemplateDuty', $templates),
            countryOption: $countries.find('option').clone(),
            notes: jqAlta('.altaTaksaTemplateNotes', $templates)
        },
        currencySign = {
            'USD': ' &#36;',
            'EUR': ' &euro;',
            'RUR': ' &#8381;',
            'AUD': ' &#36;A',
            'AZN': ' &#8380;',
            'AMD': ' &#1423;',
            'GBP': ' &#163;',
            'JPY': ' &#165;',
            'CAD': ' C&#36;',
            'CNY': ' &#165;',
            'UAH': ' &#8372;',
            'PLN': ' z&#x142;',
            'CZK': ' K&#x10D;',
            'BRL': ' &#82;&#36;',
            'TRY': ' &#8378;',
            'INR': ' &#8360;',
            'KRW': ' &#8361;',
            'KZT': ' &#8376;',
            'BYN': ' р.',
            'BGN': ' лв.',
            'HUF': ' Ft',
            'HKD': ' HK&#36;',
            'DKK': ' kr.',
            'KGS': ' с',
            'MDL': ' L',
            'RON': ' lei',
            'TMT': ' m',
            'NOK': ' &#107;&#114;',
            'SGD': ' S&#36;',
            'TJS': ' смн.',
            'UZS': ' Som',
            'SEK': ' &#107;&#114;',
            'CHF': ' &#8355;',
            'ZAR': ' R'
        },
        now = new Date(),
        formattedDate = ((now.getDate() < 10) ? '0' + now.getDate() : now.getDate()) + '.' + ('0' + (now.getMonth() + 1)).slice(-2) + '.' + now.getFullYear();

    $contract.isEd
        .closest('.altaTaksaForm__row')
        .insertAfter($contract.special);

    var printError = function (message) {
        $formErrors.append('<li>' + message + '</li>')
    }

    var addLoader = function ($element) {
        $element.addClass('altaTaksaLoader');
    }

    var removeLoader = function ($element) {
        $element.removeClass('altaTaksaLoader');
    }

    var codeIsValid = function () {
        var result = false,
            code = $tnvedCode.val() + '';

        if (tnvedRegexp.test(code)) {
            result = true;
        } else {
            printError('Введите код ТНВЭД (10 цифр)')
        }

        return result;
    }

    var dateIsValid = function () {
        var result = false,
            value = '' + $date.val();

        if ((/^\s*(3[01]|[12][0-9]|0?[1-9])\.(1[012]|0?[1-9])\.((?:19|20)\d{2})\s*$/).test(value)) {
            result = true;
        } else {
            printError('Введите дату в формате дд.мм.гггг')
        }

        return result;
    }

    var tnvedCountryIsValid = function () {
        var result = false;

        if (jqAlta('#alta_taksa_tncountry').val() === jqAlta('#alta_taksa_countries').val()) {
            result = true;
        } else {
            printError('Некорректный код страны')
        }

        return result;
    }

    var formIsValid = function () {
        $formErrors.html('');

        return codeIsValid() && dateIsValid() && tnvedCountryIsValid();
    }

    var showParamsError = function (error) {
        $params.errors.html('В результате запроса произошла ошибка: ' + error);
        $params.errors.removeClass('invisible');
        $params.container.addClass('invisible');
        $calc.table.addClass('invisible');
        $contractForm.addClass('invisible');
        removeLoader($container);
    }

    var showNotesError = function (error) {
        $notesErrors.html('В результате запроса произошла ошибка: ' + error);
        $notesErrors.removeClass('invisible');
        $notes.addClass('invisible');
        removeLoader($container);
    }

    var clearParams = function () {
        $params.errors.addClass('invisible');
        $params.container.addClass('invisible');
        $calc.table.addClass('invisible');
        $contractForm.addClass('invisible');
        $contract.cost.val('');
        $contract.all.val('');
        $contract.duty.val('');
        $contract.acc.val('');
        $contract.ed.val('');
        $tnvedTitle.html('').addClass('invisible');
    }

    if ($calcBtn.length !== 0) {
        $form
            .on('submit', function (evt) {
                evt.preventDefault()

                if (formIsValid()) {
                    if ($form.data('request-type') === $calcBtn.attr('name')) {
                        getContractParams();
                    } else if ($form.data('request-type') === $notesBtn.attr('name')) {
                        getNotes();
                    }

                    $calcBtn.removeClass('altaTaksaButton--warning');
                    $notesBtn.removeClass('altaTaksaButton--warning');
                    $formErrors.addClass('invisible');
                } else {
                    $formErrors.removeClass('invisible');
                }
            })
            .on('change input', function () {
                $formErrors.addClass('invisible');
                $notes.addClass('invisible');

                if (formIsValid()) {
                    $calcBtn.addClass('altaTaksaButton--warning').prop('disabled', false);
                    $notesBtn.addClass('altaTaksaButton--warning').prop('disabled', false);
                    $hintsWrapper.addClass('invisible');
                } else {
                    $calcBtn.removeClass('altaTaksaButton--warning').prop('disabled', true);
                    $notesBtn.removeClass('altaTaksaButton--warning').prop('disabled', true);
                }

                clearParams();
            })

        $calcBtn
            .on('click', function () {
                $form.data('request-type', jqAlta(this).attr('name'));
                $form.trigger('submit');
            })

        $notesBtn
            .on('click', function () {
                $form.data('request-type', jqAlta(this).attr('name'));
                $form.trigger('submit');
            });
    }

    $form.trigger('change');

    jqAlta.ajax({
        url: config.PATH,
        data: {countries: 1},
        beforeSend: function () {
            addLoader($container)
        },
        complete: function () {
            removeLoader($container)
        }
    })
        .done(function (data) {
            var response = JSON.parse(data);

            $formErrors.addClass('invisible');
            $countries.html('');

            response.Country.forEach(function (countryData) {
                var $option = $template.countryOption.clone();

                $option
                    .val(countryData.Code)
                    .html(countryData.Name)
                    .prop('selected', countryData.Code === config.DEFAULT_COUNTRY_CODE)
                    .appendTo($countries);
            });

            $countries.on('change', function () {
                $countryCode.val(jqAlta(this).children('option:selected').val());
            });

            $countries.trigger('change');

            $countryCode.on('input', function () {
                var code = $countryCode.val().toUpperCase(),
                    $option = $countries.find('option[value="' + code + '"]');

                $countryCode.val(code);

                if ($option.length !== 0) {
                    $option.prop('selected', true);
                }
            });
        })
        .fail(function () {
            printError(config.CONNECT_ERROR);
            $formErrors.removeClass('invisible');
        });

    $date.val(formattedDate);

    $contractForm
        .on('input', function (evt) {
            var $field = jqAlta(evt.target),
                value = $field.val();

            $field.val(value.replace(/,/g, '.'));
        })

    // !-- Подсказки
    jqAlta(document)
        .on('mouseup', function (evt) {
            if ((!$hintsWrapper.is(evt.target) && $hintsWrapper.has(evt.target).length === 0) &&
                (!$clear.is(evt.target) && $clear.has(evt.target).length === 0) &&
                (!$tnvedCode.is(evt.target) && $tnvedCode.has(evt.target).length === 0)) {
                $hintsWrapper.addClass('invisible');
                jqAlta('.altaTaksaHelper__line--default', $hints).remove();
                jqAlta('.altaTaksaHelper__line--apu', $hintsApu).remove();
            }
        });

    $clear
        .on('click', function () {
            $tnvedCode.val('');
            $clear.addClass('invisible');
        });

    $tnvedCode
        .on('input', function () {
            if (globalTimeout !== null) {
                clearTimeout(globalTimeout);
            }

            globalTimeout = setTimeout(function () {
                var value = $tnvedCode.val() + '';

                if (value !== '') {
                    $clear.removeClass('invisible');
                } else {
                    $clear.addClass('invisible');
                }

                if (value.length > 2 && !codeIsValid()) {
                    getHints()
                } else if (value.length <= 2) {
                    jqAlta('.altaTaksaLoader').remove();
                    $hintsWrapper.addClass('invisible');
                }
            }, 500);
        });

    $formTypeSwitch
        .on('change', function () {
            var $label = jqAlta('#alta_taksa_country_label');

            $label.text($label.data(jqAlta(this).filter(':checked').val()))
        })

    $content.on('change keyup', function () {
        calculate();
    });

    var fillTnved = function (code) {
        $tnvedCode.val(code);
        $hints.addClass('invisible');
        $hintsApu.addClass('invisible');
        $hintsWrapper.addClass('invisible');
        $form.trigger('change');
    }

    function getSbor(type) {
        var isImport = (type === 'import'),
            requestData = {
                tnved: $tnvedCode.val(),
                date: formatUserDate($date.val())
            };

        isImport ? requestData.sbor = 1 : requestData.exSbor = 1;

        jqAlta.ajax({
            url: config.PATH,
            data: requestData,
            success: function (data) {
                isImport ? sborImportData = JSON.parse(data) : sborExportData = JSON.parse(data);

                checkLoadDataStatus();
            },
            error: function () {
                console.warn(config.CONNECT_ERROR)
            },
            complete: function () {
            }
        });
    }

    function getHints() {
        globalTimeout = null;
        $hintsWrapper.removeClass('invisible');
        $hints.removeClass('invisible');
        addLoader($hints)

        // Обращение за подсказками к xml_search
        jqAlta.get(config.PATH, {
            search: $tnvedCode.val(),
            limit: config.LIMIT_HINTS
        })
            .done(function (data) {
                var response = JSON.parse(data),
                    hints = [];

                jqAlta('.altaTaksaHelper__line--default', $hints).remove();

                if (response.i) {
                    Array.isArray(response.i) ? hints = response.i : hints.push(response.i);

                    hints.forEach(function (hintData) {
                        var $hint = $template.hint.clone();

                        jqAlta('.altaTaksaHelper__code', $hint).html(hintData.tncode);
                        jqAlta('.altaTaksaHelper__description', $hint).html(hintData.descr + ((jqAlta.isEmptyObject(hintData.descr_sh) ? '' : ' (' + hintData.descr_sh + ')')));

                        // ТН ВЭД не содержит точку, значит конечный код ТН ВЭД
                        if (hintData.tnved.length === 10) {
                            $hint.addClass('altaTaksaHelper__line--root');
                            $hint.data('tnved', hintData.tnved);
                        } else {
                            $hint.data('uin', hintData.g.split(':')[0]);
                        }

                        $hint
                            .on('click', getCodesByHint)
                            .appendTo($hints);
                    });
                } else {
                    $hints.addClass('invisible');
                }

                removeLoader($hints)
            })
            .fail(function () {
                printError(config.CONNECT_ERROR);
                $formErrors.removeClass('invisible');
            });

        // Обращение за подсказками к xml_apu
        if (config.USE_APU) {
            $hintsApu.removeClass('invisible');
            addLoader($hintsApu);

            jqAlta.get(config.PATH, {
                apu: $tnvedCode.val(),
                limit: config.LIMIT_HINTS
            })
                .done(function (data) {
                    var response = JSON.parse(data),
                        hints = [];

                    jqAlta('.altaTaksaHelper__line--apu', $hintsApu).remove();

                    if (response.line) {
                        Array.isArray(response.line) ? hints = response.line : hints.push(response.line);

                        hints.forEach(function (hintData) {
                            var $hint = $template.hintApu.clone();

                            jqAlta('.altaTaksaHelper__code', $hint).remove();
                            jqAlta('.altaTaksaHelper__description', $hint).html(hintData.term);
                            $hint
                                .data('uin', hintData.payload);

                            $hint
                                .on('click', getApuCodesByHint)
                                .appendTo($hintsApu);
                        });
                    } else {
                        $hintsApu.addClass('invisible');
                    }

                    removeLoader($hintsApu);
                })
                .fail(function () {
                    printError(config.CONNECT_ERROR);
                    $formErrors.removeClass('invisible');
                });
        }
        if ($hints.hasClass('invisible') && $hintsApu.hasClass('invisible')) {
            $hintsWrapper.addClass('invisible');
        }
    }

    function getCodesByHint() {
        var uin = jqAlta(this).data('uin'),
            tnved = jqAlta(this).data('tnved');

        $hintsApu.addClass('invisible');
        $hints.removeClass('invisible');
        addLoader($hints);

        if (uin) {
            jqAlta.get(config.PATH, {
                search_code: uin,
                limit: config.LIMIT_HINTS
            })
                .done(function (data) {
                    var response = JSON.parse(data),
                        hints = [];

                    jqAlta('.altaTaksaHelper__line--default', $hints).remove();

                    if (response.i) {
                        Array.isArray(response.i) ? hints = response.i : hints.push(response.i);

                        hints.forEach(function (hintData) {
                            var $hint = $template.hint.clone();

                            jqAlta('.altaTaksaHelper__code', $hint).html(hintData.tncode);
                            jqAlta('.altaTaksaHelper__description', $hint).html(hintData.descr + ((jqAlta.isEmptyObject(hintData.descr_sh) ? '' : ' (' + hintData.descr_sh + ')')));

                            $hint
                                .data('tnved', hintData.tnved)
                                .addClass('altaTaksaHelper__line--root')
                                .on('click', getCodesByHint)
                                .appendTo($hints);
                        });
                    } else {
                        $hints.addClass('invisible');
                        if ($hints.hasClass('invisible') && $hintsApu.hasClass('invisible')) {
                            $hintsWrapper.addClass('invisible');
                        }
                    }
                    removeLoader($hints);
                })
                .fail(function () {
                    printError(config.CONNECT_ERROR);
                    $formErrors.removeClass('invisible');
                });
        } else if (tnved) {
            fillTnved(tnved)
        }
    }

    function getApuCodesByHint() {
        var uin = jqAlta(this).data('uin'),
            tnved = jqAlta(this).data('tnved');

        addLoader($hintsApu);
        $hints.addClass('invisible');
        $hintsApu.removeClass('invisible');

        if (uin) {
            jqAlta.get(config.PATH, {
                apu_code: uin,
                limit: config.LIMIT_HINTS
            })
                .done(function (data) {
                    var response = JSON.parse(data),
                        hints = [];

                    jqAlta('.altaTaksaHelper__line--apu', $hintsApu).remove();

                    if (response.line) {
                        Array.isArray(response.line) ? hints = response.line : hints.push(response.line);

                        hints.forEach(function (hintData) {
                            var $hint = $template.hintApu.clone();

                            jqAlta('.altaTaksaHelper__code', $hint).html(hintData.tncode);
                            jqAlta('.altaTaksaHelper__description', $hint).html(hintData.descr + ((jqAlta.isEmptyObject(hintData.descr_sh) ? '' : ' (' + hintData.descr_sh + ')')));

                            $hint
                                .data('tnved', hintData.tnved)
                                .addClass('altaTaksaHelper__line--root')
                                .on('click', getApuCodesByHint)
                                .appendTo($hintsApu);
                        });
                    } else {
                        $hintsApu.addClass('invisible');
                        if ($hints.hasClass('invisible') && $hintsApu.hasClass('invisible')) {
                            $hintsWrapper.addClass('invisible');
                        }
                    }

                    removeLoader($hintsApu);
                })
                .fail(function () {
                    printError(config.CONNECT_ERROR);
                    $formErrors.removeClass('invisible');
                });
        } else if (tnved) {
            fillTnved(tnved)
        }
    }

    function getNotes() {
        var requestData = {data: $form.serialize()};

        function isJsonString(str) {
            try {
                JSON.parse(str);
            } catch (e) {
                return false;
            }
            return true;
        }

        isFormTypeImport() ? requestData.hint = 1 : requestData.expHint = 1;

        jqAlta.ajax({
            url: config.PATH,
            data: requestData,
            beforeSend: function () {
                $notes.addClass('invisible');
                addLoader($container);
                $notesBtn.prop('disabled', true);
            },
            success: function (data) {
                if (isJsonString(data)) {
                    var error = JSON.parse(data);
                    showNotesError(error.ErrorDescr);
                } else {
                    $notesErrors.addClass('invisible');
                    printNotes(data);
                    $notes.removeClass('invisible');
                }
            },
            error: function () {
                console.warn(config.CONNECT_ERROR);
            },
            complete: function () {
                removeLoader($container);
                $notesBtn.prop('disabled', false);
            }
        });
    }

    function printNotes(notesHtml) {
        $notesList.empty();

        var $notesSource = jqAlta('<div></div>').html(notesHtml);

        $notesSource.find('table.bordered').addClass('altaTaksaTable').removeClass('bordered');
        $notesSource.find('.altaTaksaTable tbody').addClass('altaTaksaTable__tbody');
        $notesSource.find('.altaTaksaTable tr').addClass('altaTaksaTable__row');
        $notesSource.find('.altaTaksaTable td').addClass('altaTaksaTable__td');
        $notesSource.find('.black.bold').addClass('altaTaksaNote__header').removeClass('black bold');
        $notesSource.find('.p-10').addClass('altaTaksaNote__body').removeClass('p-10');

        jqAlta('.altaTaksaNote__header', $notesSource)
            .on('click', function () {
                jqAlta(this).toggleClass('altaTaksaNote__header--active');
            })

        $notesList.append($notesSource);
    }

    function checkLoadDataStatus() {
        if (loadFlag === loadFlagComplete) {
            if (!errorFlag) {
                showParamsForm();
                $params.errors.addClass('invisible');
                $contractForm.removeClass('invisible');
                $params.container.removeClass('invisible');
            } else {
                $params.errors.removeClass('invisible');
                $contractForm.addClass('invisible');
                $params.container.addClass('invisible');
            }

            $calcBtn.prop('disabled', false);
            removeLoader($container);
        } else {
            loadFlag++;
        }
    }

    function isFormTypeImport() {
        return $formTypeSwitch.filter(':checked').val() === 'import';
    }

    function getContractParams() {
        var requestData = {data: $form.serialize()};

        clearParams()
        loadFlag = 0;
        errorFlag = false;
        loadFlagComplete = 2;
        addLoader($container);
        getSbor('import');

        if (isFormTypeImport()) {
            requestData.goodinfo = 1
        } else {
            loadFlagComplete++;
            requestData.expGoodinfo = 1;
            getSbor('export');
        }

        jqAlta.ajax({
            url: config.PATH,
            data: requestData,
            success: function (data) {
                var res = JSON.parse(data);

                xmlBase = res;

                console.info('xmlBase', xmlBase);

                if (res.ErrorCode) {
                    showParamsError(res.ErrorDescr);
                    errorFlag = true;
                    checkLoadDataStatus();
                } else {
                    $tnvedTitle.html(xmlBase.Name);

                    // Пошлина
                    var $dutyList = $params.duty.find('.jAltaTaksaDutyList'),
                        dutyDataList = [],
                        dutyTypeData = res.hasOwnProperty('Importlist') ? res.Importlist.Import : res.Exportlist.Export;

                    Array.isArray(dutyTypeData) ? dutyDataList = dutyTypeData : dutyDataList.push(dutyTypeData);

                    $dutyList.html('');

                    dutyDataList.forEach(function (dutyData, index) {
                        var $option = $template.duty.find('.altaTaksaOption').clone(),
                            name = dutyData.Value;

                        name += dutyData.Prim ? ' ' + dutyData.Prim : '';

                        jqAlta('.altaTaksaOption__radio', $option)
                            .val(index)
                            .data('text', dutyData.Value)
                            .data('razm', dutyData.Measure.Razm)
                            .data('measure', dutyData.Measure.Name)
                            .addClass(dutyDataList.length === 1 ? 'altaTaksaOption__radio--single' : '')
                            .prop('checked', index === 0);

                        if (dutyData.Note && dutyData.Note === 'Антидемпинговая пошлина') {
                            $option
                                .find('.altaTaksaOption__radio')
                                .attr('name', 'tnduty_antidumping')
                                .prop('checked', $dutyList.find('input[name="tnduty_antidumping"]').length === 0);
                        }

                        jqAlta('.altaTaksaOption__label', $option).html(name);

                        if (typeof dutyData.Link === 'string') {
                            jqAlta('.altaTaksaOption__order', $option)
                                .prop('href', dutyData.Link)
                                .html('(' + dutyData.Order + ')')
                        } else {
                            jqAlta('.altaTaksaOption__order', $option).remove();
                        }

                        if (dutyData.OrderCond) {
                            jqAlta('.altaTaksaOption__orderCond', $option).html(dutyData.OrderCond)
                        }

                        $option.appendTo($dutyList);

                        if (dutyData.NoteAdd && $dutyList.find('.altaTaksaOnline__note_add').length === 0) {
                            $option.prepend('<div class="altaTaksaOnline__note_add">' + dutyData.NoteAdd + '</div>');
                        }

                        if (dutyData.Note && $dutyList.find('.altaTaksaOnline__note').length === 0) {
                            $option.prepend('<div class="altaTaksaOnline__note">' + dutyData.Note + '</div>');
                        }
                    });

                    // Акциз
                    var $accList = $params.acc.find('.jAltaTaksaAccList'),
                        accDataList = [];

                    $accList.html('');

                    if (res.Exciselist.hasOwnProperty('Excise')) {
                        Array.isArray(res.Exciselist.Excise) ? accDataList = res.Exciselist.Excise : accDataList.push(res.Exciselist.Excise);

                        accDataList.forEach(function (accData, index) {
                            var name = (typeof accData.Value === "string" && accData.Value !== '0') ? accData.Value : config.NO_TAX;
                            name += (typeof accData.Condition === "string" && accData.Condition !== '' && accData.Condition !== name) ? " " + accData.Condition : '';

                            if (accData.Value === '0' && accData.Condition === config.NO_TAX_CONDITION) {
                                name = accData.Condition;
                            }

                            var $option = $template.acc.find('.altaTaksaOption').clone()

                            jqAlta('.altaTaksaOption__radio', $option)
                                .val(index)
                                .data('text', accData.Value)
                                .data('razm', accData.Measure.Razm)
                                .data('measure', accData.Measure.Name)
                                .data('prim', (accData.Prim ? 'special' : '')) // !-- Кисина, отмечаю ставку акциза особенной если она таковая
                                .addClass(accDataList.length === 1 ? 'altaTaksaOption__radio--single' : '')
                                .prop('checked', index === 0);

                            jqAlta('.altaTaksaOption__label', $option).html(name);

                            $option.appendTo($accList);
                        });
                    } else {
                        var $option = $template.acc.find('.altaTaksaOption').clone();

                        jqAlta('.altaTaksaOption__radio', $option).prop('checked', true).addClass('altaTaksaOption__radio--single');
                        jqAlta('.altaTaksaOption__label', $option).html(config.NO_TAX_CONDITION);
                        $option.appendTo($accList);
                    }

                    // НДС
                    var $ndsList = $params.nds.find('.jAltaTaksaNdsList'),
                        ndsDataList = [],
                        directory = '';

                    $ndsList.html('');

                    if (res.hasOwnProperty('VATlist')) {
                        Array.isArray(res.VATlist.VAT) ? ndsDataList = res.VATlist.VAT : ndsDataList.push(res.VATlist.VAT);

                        ndsDataList.forEach(function (ndsData, index) {
                            var $option = $template.nds.find('.altaTaksaOption').clone(),
                                name = (typeof ndsData.Value === "string" && ndsData.Value !== '0') ? ndsData.Value : '';

                            name += (typeof ndsData.Condition === "string" && ndsData.Condition !== '') ? " " + ndsData.Condition : '';

                            jqAlta('.altaTaksaOption__radio', $option)
                                .val(ndsData.ValueDetail.ValueCount)
                                .data('text', ndsData.Value)
                                .addClass(ndsDataList.length === 1 ? 'altaTaksaOption__radio--single' : '')
                                .prop('checked', index === 0);

                            jqAlta('.altaTaksaOption__label', $option).html(name)

                            if (ndsData.Directory && directory !== ndsData.Directory.EnName) {
                                if (ndsData.Directory.RuName.length) {
                                    $ndsList.append('<div class="altaTaksaFormDirectory">' + ndsData.Directory.RuName + '</div>');
                                }
                                if (ndsData.Directory.EnName.length) {
                                    directory = ndsData.Directory.EnName;
                                }
                            }

                            $option.appendTo($ndsList)
                        });

                        $params.nds.removeClass('invisible');
                    } else {
                        $params.nds.addClass('invisible test');
                    }

                    checkLoadDataStatus();
                }
            },
            error: function () {
                showParamsError(config.CONNECT_ERROR);
            }
        })

        var currencyDate = now.getFullYear() + '-' + ('0' + (now.getMonth() + 1)).slice(-2) + '-' + ((now.getDate() < 10) ? '0' + now.getDate() : now.getDate());
        var currencyUserDate = formatUserDate($date.val());

        if (currencyUserDate && currencyUserDate <= currencyDate)
            currencyDate = currencyUserDate;

        jqAlta.ajax({
            url: config.PATH,
            data: {get_currency: 1, date: currencyDate},
            success: function (data) {
                data = JSON.parse(data).reverse();

                jsonCurrency = data;

                if (data.result === 'error') {
                    showParamsError(data.result);
                } else {
                    checkLoadDataStatus();
                }
            },
            error: function () {
                showParamsError(config.CONNECT_ERROR);
            }
        });

        return false;
    }

    function showParamsForm() {
        var currencyUserDate = $date.val(),
            edExpirationDate = +new Date('2020-08-01');

        var enableFields = function ($fields) {
            $fields = Array.isArray($fields) ? $fields : [$fields];

            $fields.forEach(function ($field) {
                $field.prop('disabled', false).closest('.altaTaksaForm__group').removeClass('invisible');
            })
        }

        var disableFields = function ($fields) {
            $fields = Array.isArray($fields) ? $fields : [$fields];

            $fields.forEach(function ($field) {
                $field.prop('disabled', true).closest('.altaTaksaForm__group').addClass('invisible');
            })
        }

        $paramsUser.usdRate = parseFloat(jsonCurrency.filter(function (cur) {
            return cur.code === '840'
        })[0].rate);

        $paramsUser.euroRate = parseFloat(jsonCurrency.filter(function (cur) {
            return cur.code === '978'
        })[0].rate);

        $paramsUser.digitCurrencyDate = +new Date(currencyUserDate.replace(/^(\d{2})\.(\d{2})\.(\d{4})/, '$3-$2-$1'));

        if ($paramsUser.digitCurrencyDate < edExpirationDate) {
            $contract.isEd
                .prop('checked', true)
                .closest('.altaTaksaForm__row')
                .removeClass('invisible');
        } else {
            $contract.isEd
                .prop('checked', false)
                .closest('.altaTaksaForm__row')
                .addClass('invisible');
        }

        var $accOption = $params.acc.find('input[name=tnacc]'),
            $dutyOption = $params.duty.find('input[name=tnduty]'),
            $dutyOptionAntiDumping = $params.duty.find('input[name=tnduty_antidumping]');

        $paramsUser.accOption = $accOption.filter(':checked');
        $paramsUser.dutyOption = $dutyOption.filter(':checked');
        $paramsUser.dutyOptionAntiDumping = null;

        if ($dutyOptionAntiDumping.length !== 0) {
            $paramsUser.dutyOptionAntiDumping = $dutyOptionAntiDumping.filter(':checked');

            $dutyOptionAntiDumping.on('change', function () {
                $paramsUser.dutyOptionAntiDumping = $params.duty.find('input[name=tnduty_antidumping]:checked');
            })
        }

        $contract.currency.empty();
        printCurrencyList();

        $contract.currentCost.addClass('invisible');
        $contract.currentCostValue.val('');
        $contract.eur.val($paramsUser.euroRate.toFixed(2));
        $contract.usd.val($paramsUser.usdRate.toFixed(2));
        jqAlta('#alta_taksa_duty_measure_name').html($paramsUser.dutyOption.data('measure'));
        jqAlta('#alta_taksa_duty_measure_razm').html($paramsUser.dutyOption.data('razm'));
        jqAlta('#alta_taksa_acc_measure_name').html($paramsUser.accOption.data('measure'));
        jqAlta('#alta_taksa_acc_measure_razm').html($paramsUser.accOption.data('razm'));

        var toggleContractFields = function () {
            enableFields([$contract.cost, $contract.acc, $contract.all, $contract.duty, $contract.ed]);

            if (xmlBase.hasOwnProperty('Exportlist')) {
                var exportData = xmlBase.Exportlist.Export,
                    selectedExport = Array.isArray(exportData) ? exportData[$paramsUser.dutyOption.val()] : exportData;

                if ((selectedExport.hasOwnProperty('ValueDetail') && selectedExport.ValueDetail.ValueUnit === '%' &&
                    !selectedExport.ValueDetail.hasOwnProperty('ValueCount2') && !selectedExport.hasOwnProperty('BasePrice') &&
                    selectedExport.Value !== config.NO_DUTY)) {
                    //пошлина - это процент от стоимости, запрашиваем стоимость контракта
                    disableFields([$contract.duty, $contract.ed]);
                } else if (selectedExport.hasOwnProperty('ValueDetail') && selectedExport.ValueDetail.hasOwnProperty('ValueUnit')
                    && !selectedExport.ValueDetail.hasOwnProperty('ValueCount2') && !selectedExport.hasOwnProperty('BasePrice') &&
                    selectedExport.Value !== config.NO_DUTY) {
                    //пошлина специфическая, запрашиваем кол-во товаров/тонн
                    disableFields([$contract.cost, $contract.ed]);
                } else if (selectedExport.Value === config.NO_DUTY ||
                    (selectedExport.Value && selectedExport.hasOwnProperty('ValueDetail') &&
                        !selectedExport.ValueDetail.hasOwnProperty('ValueCount'))) {
                    //пошлины по экспорту нет - считать нечего, поэтому запрашивать стоимость контракта с кол-вом товара не надо
                    disableFields([$contract.cost, $contract.acc, $contract.all, $contract.duty, $contract.ed]);
                }
            }

            // Если выбирают "особенный" акциз, то нужно показывать доп строку для ввода параметров расчета акциз
            if ($paramsUser.accOption.data('prim') === 'special') {
                $contract.special.removeClass('invisible');
                jqAlta('#alta_taksa_special_acc_measure_razm').html($paramsUser.accOption.data('razm'));
            } else {
                $contract.special.addClass('invisible');
            }
            // --!
            if ($paramsUser.dutyOption.data('razm') === $paramsUser.accOption.data('razm')) {
                $contract.duty.closest('.altaTaksaForm__group').addClass('invisible');
                $contract.acc.closest('.altaTaksaForm__group').addClass('invisible');
                jqAlta('#alta_taksa_all_measure_name').html($paramsUser.accOption.data('measure'));
                jqAlta('#alta_taksa_all_measure_razm').html($paramsUser.accOption.data('razm'));
                $contract.all.not(':disabled').closest('.altaTaksaForm__group').removeClass('invisible');
            } else {
                $contract.duty.not(':disabled').closest('.altaTaksaForm__group').removeClass('invisible');
                $contract.acc.not(':disabled').closest('.altaTaksaForm__group').removeClass('invisible');
                $contract.all.closest('.altaTaksaForm__group').addClass('invisible');
                $contract.all.val('');
            }

            if ($paramsUser.accOption.data('text') === '0') {
                $contract.acc
                    .prop('readonly', true)
                    .addClass('altaTaksaForm__control--readonly');
            } else {
                $contract.acc
                    .prop('readonly', false)
                    .removeClass('altaTaksaForm__control--readonly');
            }
            if (xmlBase.hasOwnProperty('Exciselist') && !xmlBase.Exciselist.hasOwnProperty('Excise')) {
                disableFields($contract.acc);
            }
            jqAlta('#alta_taksa_acc_measure_name').html($paramsUser.accOption.data('measure'));
            jqAlta('#alta_taksa_acc_measure_razm').html($paramsUser.accOption.data('razm'));

            calculate();
        }

        $dutyOption.on('change', function () {
            $paramsUser.dutyOption = $params.duty.find('input[name=tnduty]:checked');

            toggleContractFields();
        })

        $accOption.on('change', function () {
            $paramsUser.accOption = jqAlta(this); // актуализируем значения

            toggleContractFields();
        });

        $contract.currency
            .on('change', function () {
                var $selectedCurrency = jqAlta(this).find('option:selected'),
                    currentCount = $selectedCurrency.data('count'),
                    currentFloatRate = parseFloat($selectedCurrency.data('rate')).toFixed(2),
                    currencySignSelected = '';

                if (jqAlta(this).val() !== 'USD' && jqAlta(this).val() !== 'EUR' && jqAlta(this).val() !== 'RUR') {
                    $contract.currentCost.removeClass('invisible');
                    $contract.currentCostValue.val(currentFloatRate);

                    if (currencySign[$contract.currency.val()]) {
                        currencySignSelected = currencySign[$contract.currency.val()]
                    } else {
                        currencySignSelected = ' ' + $contract.currency.val()
                    }
                    $contract.currentCount.html(currentCount);
                    $contract.currentSign.html(currencySignSelected);
                } else {
                    $contract.currentCost.addClass('invisible');
                }
            })

        toggleContractFields();
    }

    function calculate() {
        var $selectedCurrency = $contract.currency.find('option:selected'),
            currentRate = parseFloat($selectedCurrency.data('rate')),
            currentFloatRate = +currentRate.toFixed(2);

        $calc.table.addClass('invisible');

        if ($contract.all.val()) {
            $contract.duty.val($contract.all.val());
            $contract.acc.val($contract.all.val());
        }
        if ($contract.duty.val() && $contract.duty.val() !== '0') {
            jqAlta('input[name=cost_ed]').val($contract.cost.val() / $contract.duty.val());
        }
        var contractFormState = checkContractForm($paramsUser.accOption);

        if (contractFormState.isValid) {
            var usdValue = parseFloat($contract.usd.val() + ''),
                euroValue = parseFloat($contract.eur.val() + ''),
                currentUsd = (usdValue === +$paramsUser.usdRate.toFixed(2)) ? $paramsUser.usdRate : usdValue,
                currentEuro = (euroValue === +$paramsUser.euroRate.toFixed(2)) ? $paramsUser.euroRate : euroValue,
                mainCurrency = {
                    'USD': currentUsd,
                    'EUR': currentEuro,
                    'RUR': 1
                },
                mainCurrencyRate = mainCurrency[$contract.currency.val()],
                currencySignSelected = '',
                currencySelected = 0;

            if (mainCurrencyRate) {
                currencySelected = (mainCurrencyRate === currentFloatRate) ? currentRate : mainCurrencyRate;
                currencySignSelected = currencySign[$contract.currency.val()]
            } else {
                var currentCostValue = parseFloat($contract.currentCostValue.val() + '');
                currencySelected = (currentCostValue === currentFloatRate) ? currentRate : currentCostValue;
                currencySignSelected = $contract.currentSign.html()
            }

            if (currencySelected !== 1) {
                $calc.table.find('thead th').eq(3).removeClass('invisible');
                currencySelected = currencySelected / $contract.currency.find('option:selected').data('count');
            } else {
                $calc.table.find('thead th').eq(3).addClass('invisible');
            }

            // Таможенный сбор
            var sborBase = 0,
                isCostEnabled = !$contract.cost.prop('disabled'),
                costContractRur = isCostEnabled ? (+$contract.cost.val() * currencySelected) : 0,
                sborData = isCostEnabled ? sborImportData : sborExportData,
                sborValue = isCostEnabled ? costContractRur : 1,
                sborNote = isCostEnabled ? '' : ' (для одного товара в ДТ)';

            if (!$contract.cost.prop('disabled') || !$contract.duty.prop('disabled')) {
                var fixedSbor = sborData.filter(function (cur) {
                    return cur.hasOwnProperty('sbor2023');
                });

                if (fixedSbor.length === 0) {
                    sborData.forEach(function (cur) {
                        if ((+cur.MINCOST <= sborValue && cur.MINCOST !== '')
                            && (+cur.MAXCOST >= sborValue || cur.MAXCOST === '')
                            && ($paramsUser.digitCurrencyDate >= +new Date(cur.ST_DT) || cur.ST_DT === '1970-01-01')
                            && ($paramsUser.digitCurrencyDate <= +new Date(cur.STP_DT) || cur.STP_DT === '1970-01-01')) {
                            sborBase = cur.RATE;

                            var found = sborBase.match(/([0-9.-]+)/ig);

                            if (found.length !== 0)
                                sborBase = found[0];
                        }
                    });
                } else {
                    sborBase = fixedSbor[0].sbor2023;
                }
            }

            var sborSum = jqAlta('input[name=is_ed]').prop('checked') ? sborBase * 0.75 : sborBase;
            var sborSummCur = (sborSum / currencySelected).toFixed(2);

            $calc.sbor.eq(1).html(sborBase + currencySign['RUR'] + (sborBase !== 0 ? sborNote : ''));
            $calc.sbor.eq(2).html(parseFloat(sborSum).toFixed(2) + currencySign['RUR']);

            if (currencySelected !== 1) {
                $calc.sbor.eq(3).removeClass('invisible');
                $calc.sbor.eq(3).html(sborSummCur + currencySignSelected);
            } else {
                $calc.sbor.eq(3).addClass('invisible');
            }

            var printRow = function ($row, value, title) {
                var valueSumCurrency = (value / currencySelected).toFixed(2);

                $row.eq(1).html(title);
                $row.eq(2).html(value.toFixed(2) + currencySign['RUR']);
                if (currencySelected !== 1) {
                    $row.eq(3)
                        .removeClass('invisible')
                        .html(valueSumCurrency + currencySignSelected);
                } else {
                    $row.eq(3).addClass('invisible');
                }
            }

            var printSumRow = function ($row, value) {
                var sumCurrency = (value / currencySelected).toFixed(2);

                $row.eq(1).html(value.toFixed(2) + currencySign['RUR']);
                if (currencySelected !== 1) {
                    $row.eq(2)
                        .removeClass('invisible')
                        .html(sumCurrency + currencySignSelected);
                } else {
                    $row.eq(2).addClass('invisible');
                }
            }

            //Пошлина
            var dutyBase = $contract.duty.val(),
                dutySum = 0,
                dutyAntiDumpingSum = 0,
                dutyType = xmlBase.hasOwnProperty('Importlist') ? xmlBase.Importlist.Import : xmlBase.Exportlist.Export,
                selectedDuty = Array.isArray(dutyType) ? dutyType[$paramsUser.dutyOption.val()] : dutyType,
                selectedDutyAntiDumping = {};

            if ($paramsUser.dutyOptionAntiDumping && $paramsUser.dutyOptionAntiDumping.length !== 0) {
                selectedDutyAntiDumping = Array.isArray(dutyType) ? dutyType[$paramsUser.dutyOptionAntiDumping.val()] : dutyType;
            }

            /* Пошлина 0, если удобрения продаются дешевле, чем 450$ за тонну. Если продаются дороже, то взимается 23.5% с разницы стоимости и порога 450$ за тонну. */
            if (selectedDuty.hasOwnProperty('BasePrice')) {
                var dutySpecial = costContractRur / dutyBase - (parseFloat(selectedDuty.BasePrice.Value) * mainCurrency[selectedDuty.BasePrice.Currency]);

                costContractRur = dutySpecial > 0 ? dutySpecial * dutyBase : 0;
            }

            if (contractFormState.type === 'request') {
                // Считаем первый вариант
                var dutySum1 = 0;

                if (+selectedDuty.Value !== 0 && selectedDuty.hasOwnProperty('ValueDetail')) {
                    dutySum1 = calcSt(selectedDuty.ValueDetail.ValueCount,
                        selectedDuty.ValueDetail.ValueUnit,
                        ((selectedDuty.ValueDetail.ValueCurrency) ? selectedDuty.ValueDetail.ValueCurrency : ''),
                        costContractRur,
                        dutyBase,
                        currentEuro,
                        currentUsd
                    );
                }

                // Если составная - ставка вычисляем и добавляем вторую часть
                if (selectedDuty.ValueDetailAdd) {
                    dutySum1 += calcSt(selectedDuty.ValueDetailAdd.ValueCount,
                        selectedDuty.ValueDetailAdd.ValueUnit,
                        ((selectedDuty.ValueDetailAdd.ValueCurrency) ? selectedDuty.ValueDetailAdd.ValueCurrency : ''),
                        costContractRur,
                        dutyBase,
                        currentEuro,
                        currentUsd);
                }

                dutySum = dutySum1;

                // если есть условие не менее
                if (selectedDuty.ValueDetail && selectedDuty.ValueDetail.ValueCount2) {
                    // Считаем второй вариант
                    var dutySum2 = calcSt(selectedDuty.ValueDetail.ValueCount2,
                        selectedDuty.ValueDetail.ValueUnit2,
                        ((selectedDuty.ValueDetail.ValueCurrency2) ? selectedDuty.ValueDetail.ValueCurrency2 : ''),
                        costContractRur,
                        dutyBase,
                        currentEuro,
                        currentUsd
                    );

                    // Если есть условие не более
                    var dutySum3 = 0;

                    if (selectedDuty.ValueDetail.ValueCount3) {
                        dutySum3 = calcSt(selectedDuty.ValueDetail.ValueCount3,
                            selectedDuty.ValueDetail.ValueUnit3,
                            ((selectedDuty.ValueDetail.ValueCurrency3) ? selectedDuty.ValueDetail.ValueCurrency3 : ''),
                            costContractRur,
                            dutyBase,
                            currentEuro,
                            currentUsd
                        );
                    }
                    // Выбираем больший, но ставку с "не менее" сравниваем со ставкой "не более" и выбираем из них меньшую
                    if (dutySum2 > dutySum1) {
                        //беру второе
                        dutySum = dutySum2;
                        if (dutySum3 && dutySum3 !== 0 && dutySum > dutySum3) {
                            dutySum = dutySum3;
                        }
                    } else {
                        dutySum = dutySum1;
                    }
                }

                if (selectedDutyAntiDumping.hasOwnProperty('Value')) {
                    dutyAntiDumpingSum = calcSt(selectedDutyAntiDumping.ValueDetail.ValueCount,
                        selectedDutyAntiDumping.ValueDetail.ValueUnit,
                        ((selectedDutyAntiDumping.ValueDetail.ValueCurrency) ? selectedDutyAntiDumping.ValueDetail.ValueCurrency : ''),
                        costContractRur,
                        dutyBase,
                        currentEuro,
                        currentUsd
                    );
                }
            }

            if (selectedDutyAntiDumping.hasOwnProperty('Value')) {
                printRow($calc.dutyAntiDumping, dutyAntiDumpingSum, $paramsUser.dutyOptionAntiDumping.data('text'));
                $calc.dutyAntiDumping.closest('tr').removeClass('invisible');
            } else {
                $calc.dutyAntiDumping.closest('tr').addClass('invisible');
            }

            printRow($calc.duty, dutySum, $paramsUser.dutyOption.data('text'))

            //Акциз
            var accBase = $contract.acc.val(),
                accIndex = parseInt($paramsUser.accOption.val()),
                accText = config.NO_TAX,
                accSum = 0;

            if (!$contract.acc.prop('disabled')) {
                var selectedAcc = Array.isArray(xmlBase.Exciselist.Excise) ? xmlBase.Exciselist.Excise[accIndex] : xmlBase.Exciselist.Excise;

                if (selectedAcc.Value !== '0') {
                    accSum = calcSt(selectedAcc.ValueDetail.ValueCount,
                        selectedAcc.ValueDetail.ValueUnit,
                        ((selectedAcc.ValueDetail.ValueCurrency) ? selectedAcc.ValueDetail.ValueCurrency : ''),
                        costContractRur, accBase, currentEuro, currentUsd
                    );
                    accText = selectedAcc.ValueDetail.ValueCount + '&nbsp;' + ((selectedAcc.ValueDetail.ValueCurrency) ? selectedAcc.ValueDetail.ValueCurrency + '/' : '') + selectedAcc.ValueDetail.ValueUnit;
                } else {
                    if (selectedAcc.Condition === config.NO_TAX_CONDITION) {
                        accText = selectedAcc.Condition;
                    }
                }

                if (selectedAcc.ValueDetailAdd) {
                    if (selectedAcc.Prim) {
                        var accSpecialPrice = $contract.specialPrice.val();
                        var accSpecialCount = (selectedAcc.Measure.Razm.search('т.шт') !== -1) ? $contract.specialCount.val() * 1000 : $contract.specialCount.val();
                        var specialCost = accSpecialPrice * accSpecialCount
                        accSum += calcSt(selectedAcc.ValueDetailAdd.ValueCount,
                            selectedAcc.ValueDetailAdd.ValueUnit,
                            ((selectedAcc.ValueDetailAdd.ValueCurrency) ? selectedAcc.ValueDetailAdd.ValueCurrency : ''),
                            specialCost,
                            accBase,
                            currentEuro,
                            currentUsd
                        );
                    } else
                        accSum += calcSt(selectedAcc.ValueDetailAdd.ValueCount,
                            selectedAcc.ValueDetailAdd.ValueUnit,
                            ((selectedAcc.ValueDetailAdd.ValueCurrency) ? selectedAcc.ValueDetailAdd.ValueCurrency : ''),
                            costContractRur,
                            accBase,
                            currentEuro,
                            currentUsd
                        );
                    accText += '+' + selectedAcc.ValueDetailAdd.ValueCount + ((selectedAcc.ValueDetailAdd.ValueCurrency) ? selectedAcc.ValueDetailAdd.ValueCurrency + '/' : '') + selectedAcc.ValueDetailAdd.ValueUnit;
                }

                if (selectedAcc.Value !== '0' && selectedAcc.ValueDetail.ValueCount2) {
                    var accSum2 = calcSt(selectedAcc.ValueDetail.ValueCount2,
                        selectedAcc.ValueDetail.ValueUnit2,
                        ((selectedAcc.ValueDetail.ValueCurrency2) ? selectedAcc.ValueDetail.ValueCurrency2 : ''),
                        costContractRur,
                        accBase,
                        currentEuro,
                        currentUsd
                    );

                    if (accSum < accSum2) {
                        accSum = accSum2;
                        accText = selectedAcc.ValueDetail.ValueCount2 + ((selectedAcc.ValueDetail.ValueCurrency2) ? selectedAcc.ValueDetail.ValueCurrency2 + '/' : '') + selectedAcc.ValueDetail.ValueUnit2;
                    }
                }
            }

            printRow($calc.acc, accSum, accText)

            //НДС
            var $ndsSelected = jqAlta('input[name=tnnds]:checked'),
                ndsSum = 0;

            if ($ndsSelected.length !== 0) {
                var ndsBase = $ndsSelected.val();

                ndsSum = (costContractRur + dutySum + accSum) * ndsBase / 100;
                $calc.nds.removeClass('invisible');
                printRow($calc.nds, ndsSum, $ndsSelected.data('text'))
            } else {
                $calc.nds.addClass('invisible');
            }

            // Итого сборов
            var sum = parseFloat(sborSum) + parseFloat(dutySum) + parseFloat(dutyAntiDumpingSum) + parseFloat(accSum) + parseFloat(ndsSum);
            printSumRow($calc.sum, sum)

            // Итого
            var total = sum + costContractRur;
            printSumRow($calc.total, total)

            $calc.table.removeClass('invisible');
        }
    }

    function checkContractForm($accSelected) {
        var result = false,
            type = 'request';

        if (($contract.cost.val() || $contract.cost.prop('disabled'))
            && ($contract.duty.val() || $contract.duty.prop('disabled'))
            && ($contract.acc.is("[readonly]") || $contract.acc.val() || $contract.acc.prop('disabled'))
            && ($accSelected.data('prim') === 'special'
                && $contract.specialPrice.val()
                && $contract.specialCount.val() || $accSelected.data('prim') !== 'special')
        ) {
            result = true;
        }

        if ($contract.cost.prop('disabled') && $contract.duty.prop('disabled') && $contract.acc.prop('disabled')) {
            type = 'ready';
        }

        return {isValid: result, type: type}
    }

    //Ставка
    function calcSt(count, unit, currency, price, base, euro_rate, usd_rate) {
        var res = 0;

        if (unit === '%') {
            return count * price * 0.01;
        } else {
            switch (currency) {
                case 'евро':
                case 'евр':
                case 'EUR':
                    res = count * euro_rate * base;
                    break;
                case 'дол':
                case 'USD':
                    res = count * usd_rate * base;
                    break;
                default:
                    res = count * base;
                    break;
            }
            return res;
        }
    }

    function printCurrencyList() {
        var $optionTpl = jqAlta('<option></option>');

        $contract.currency.append($contract.rurOption);

        jsonCurrency.forEach(function (item) {
            var $option = $optionTpl.clone();

            $option
                .text(item.code + '  ' + item.name + '  (' + item.encode + ')')
                .data('count', item.counts)
                .data('rate', item.rate)
                .val(item.encode);

            if (item.code === '840') {
                $option.prop('selected', true);
            }

            $contract.currency.append($option);
        })
    }

    function formatUserDate(date) {
        var formattedDate = false;

        if ((/^\d{2}\.\d{2}\.\d{4}/).test(date)) {
            var arrayUserDate = date.split(".");
            formattedDate = arrayUserDate[2] + "-" + arrayUserDate[1] + "-" + arrayUserDate[0];
        }

        return formattedDate;
    }
});
