<?
    $conf = parse_ini_file('conf.ini');

	$sa_login = $conf["login"];
	$sa_pass = $conf["pass"];

	if ($_GET['goodinfo'])
	{
		$values = array();
		parse_str($_GET['data'], $values);
		$tncode = preg_replace('/\s+/', '', $values["tncode"]);
		$cert = ($values["tncertificate"]) ? 1 : 0;
		$cert_eav = ($values["tncountry"] && $values["tncountry"] == 704 && $values["tncertificate"]) ? 1 : 0;
		$secret = md5($tncode . ":" . $sa_login . ":" . md5($sa_pass));
		$date = ($values["date"] && $values["date"] != "") ? $values["date"] : date('Y-m-d');
		$sContent = file_get_contents('https://www.alta.ru/tnved/xml/?tncode=' . $tncode .
																	'&login=' . $sa_login .
																	'&secret=' . $secret .
																	'&country=' . $values["tncountry"] .
																	'&certificate=' . $cert .
																	'&sp_certificate=' . $cert_eav.
																	'&date=' . $date
									);
		$xml = simplexml_load_string($sContent);
		echo json_encode($xml);
	}
	if ($_GET['hint'])
	{
		$values = array();
		parse_str($_GET['data'], $values);
		$tncode = preg_replace('/\s+/', '', $values["tncode"]);
		$cert = ($values["tncertificate"]) ? 1 : 0;
		$cert_eav = ($values["tncountry"] && $values["tncountry"] == 704 && $values["tncertificate"]) ? 1 : 0;
		$secret = md5($tncode . ":" . $sa_login . ":" . md5($sa_pass));
		$date = ($values["date"] && $values["date"] != "") ? $values["date"] : date('Y-m-d');
		$sContent = file_get_contents('https://www.alta.ru/tnved/xml_nodes/?tncode=' . $tncode .
			'&login=' . $sa_login .
			'&secret=' . $secret .
			'&country=' . $values["tncountry"] .
			'&certificate=' . $cert .
			'&sp_certificate=' . $cert_eav.
			'&date=' . $date.
			'&type_answer=html'
		);
		echo $sContent;
	}
	if ($_GET['expHint'])
	{
		$values = array();
		parse_str($_GET['data'], $values);
		$tncode = preg_replace('/\s+/', '', $values["tncode"]);
		$cert = ($values["tncertificate"]) ? 1 : 0;
		$cert_eav = ($values["tncountry"] && $values["tncountry"] == 704 && $values["tncertificate"]) ? 1 : 0;
		$secret = md5($tncode . ":" . $sa_login . ":" . md5($sa_pass));
		$date = ($values["date"] && $values["date"] != "") ? $values["date"] : date('Y-m-d');
		$sContent = file_get_contents('https://www.alta.ru/tnved/xml_nodes/?tncode=' . $tncode .
			'&login=' . $sa_login .
			'&secret=' . $secret .
			'&country=' . $values["tncountry"] .
			'&certificate=' . $cert .
			'&sp_certificate=' . $cert_eav.
			'&date=' . $date.
			'&mode=export&type_answer=html'
		);
		echo $sContent;
	}
    if ($_GET['expGoodinfo'])
    {

        $values = array();
        parse_str($_GET['data'], $values);
        $tncode = preg_replace('/\s+/', '', $values["tncode"]);
        $cert = ($values["tncertificate"]) ? 1 : 0;
        $cert_eav = ($values["tncountry"] && $values["tncountry"] == 704 && $values["tncertificate"]) ? 1 : 0;
        $secret = md5($tncode . ":" . $sa_login . ":" . md5($sa_pass));
        $date = ($values["date"] && $values["date"] != "") ? $values["date"] : date('Y-m-d');
        $sContent = file_get_contents('https://www.alta.ru/tnved/xml/?tncode=' . $tncode .
            '&login=' . $sa_login .
            '&secret=' . $secret .
            '&country=' . $values["tncountry"] .
            '&certificate=' . $cert .
            '&sp_certificate=' . $cert_eav.
            '&date=' . $date.
            '&mode=export'
        );
        $xml = simplexml_load_string($sContent);
        echo json_encode($xml);
    }
	if (isset($_GET['get_currency']) && $_GET['get_currency'])
	{
		$date = ($_GET["date"] && $_GET["date"] != "") ? $_GET["date"] : date('Y-m-d');
		$sContent = file_get_contents('https://www.alta.ru/currency/actions/currency_get.php?date=' .$date);
		echo $sContent;
	}
	if (isset($_GET['sbor']) && $_GET['sbor'])
	{
		$date = ($_GET["date"] && $_GET["date"] != "") ? $_GET["date"] : date('Y-m-d');
		$sContent = file_get_contents('https://www.alta.ru/tnved/actions/get_sbor.php?tnved='.$_GET["tnved"].'&date='.$date);
		echo $sContent;;
	}
	if ($_GET['sbor2023'])
	{
		$date = ($_GET["date"] && $_GET["date"] != "") ? $_GET["date"] : date('Y-m-d');
		$sContent = file_get_contents('https://www.alta.ru/tnved/actions/get_sbor2023.php?tnved='.$_GET["tnved"].'&date='.$date);
		echo $sContent;die;
	}
    if (isset($_GET['exSbor']) && $_GET['exSbor'])
    {
		$date = ($_GET["date"] && $_GET["date"] != "") ? $_GET["date"] : date('Y-m-d');
        $sContent = file_get_contents('https://www.alta.ru/tnved/actions/get_sbor.php?mode=export&tnved='.$_GET["tnved"].'&date='.$date);
        echo $sContent;;
    }
	if (isset($_GET['countries']) && $_GET['countries'])
	{
		$sContent = file_get_contents('https://www.alta.ru/tnved/actions/countries_xml.php');
		$xml = simplexml_load_string($sContent);
		echo json_encode($xml);
	}
	if (isset($_GET['search']) && $_GET['search'])
	{
		$values = array();
		$sContent = file_get_contents('https://www.alta.ru/tnved/xml_search/?q=' . urlencode($_GET['search']) .
																			'&limit='. $_GET['limit']);
		$xml = simplexml_load_string($sContent);
		echo json_encode($xml);
	}
	if (isset($_GET['search_code']) && $_GET['search_code'])
	{
		$values = array();
		$secret = md5($_GET['search_code'] . ":" . $sa_login . ":" . md5($sa_pass));
		$sContent = file_get_contents('https://www.alta.ru/tnved/xml_search/?code=' . $_GET['search_code'] .
																			'&login=' . $sa_login .
																			'&secret=' . $secret.
																			'&limit='. $_GET['limit']);
		$xml = simplexml_load_string($sContent);
		echo json_encode($xml);
	}
	if (isset($_GET['apu']) && $_GET['apu'])
	{
		$values = array();
		$sContent = file_get_contents('https://www.alta.ru/tnved/xml_apu/?q=' . urlencode($_GET['apu']).
																			'&limit='. $_GET['limit']);
		$xml = simplexml_load_string($sContent);
		echo json_encode($xml);
	}
	if (isset($_GET['apu_code']) && $_GET['apu_code'])
	{
		$values = array();
		$secret = md5($_GET['apu_code'] . ":" . $sa_login . ":" . md5($sa_pass));
		$sContent = file_get_contents('https://www.alta.ru/tnved/xml_apu/?code=' . $_GET['apu_code'] .
																			'&login=' . $sa_login .
																			'&secret=' . $secret.
																			'&limit='. $_GET['limit']);
		$xml = simplexml_load_string($sContent);
		echo json_encode($xml);
	}
?>
